Skip to main content
PATCH
/
public
/
v2
/
invoices
/
{record_number}
/
Update InvoiceV2 record (partial)
curl --request PATCH \
  --url https://api.dualentry.com/public/v2/invoices/{record_number}/ \
  --header 'Content-Type: application/json' \
  --header 'X-API-KEY: <api-key>' \
  --data '
{
  "custom_fields": [
    {}
  ],
  "memo": "<string>",
  "due_date": "2023-12-25",
  "company_id": 123,
  "customer_id": 123,
  "exchange_rate": 123,
  "items": [
    {
      "item_id": 123,
      "quantity": 123,
      "rate": 123,
      "position": 123,
      "memo": "<string>",
      "discount_value": 123,
      "discount_account_id": 123,
      "record_level_discount_amount": 123,
      "tax": {
        "code": "<string>",
        "rate": 123,
        "amount": 123,
        "is_taxable": true,
        "tax_exempt_amount": 123,
        "vat_rate_id": 123,
        "gst_tax_rate_id": 123
      },
      "id": 123,
      "classifications": [],
      "company_id": 123
    }
  ],
  "bill_to_address": "<string>",
  "billing_address": {
    "street": "<string>",
    "city": "<string>",
    "postal_code": "<string>",
    "state": "",
    "country": "",
    "second_line": "",
    "name": "<string>"
  },
  "ship_to_address": "<string>",
  "shipping_address": {
    "street": "<string>",
    "city": "<string>",
    "postal_code": "<string>",
    "state": "",
    "country": "",
    "second_line": "",
    "name": "<string>"
  },
  "sales_order_id": 123,
  "attachments": [
    {
      "id": 123,
      "file_name": "<string>",
      "file_size": 123,
      "download_url": "<string>",
      "upload_url": "<string>",
      "category": "default"
    }
  ],
  "contracted": false,
  "contract_id": 123,
  "term_id": 123,
  "reference_number": "",
  "ar_account_id": 123,
  "payment": {
    "type": "<string>",
    "id": 123,
    "body": "<string>",
    "link": "<string>"
  },
  "date": "2023-12-25",
  "transaction_date": "2023-12-25",
  "discount_value": 123
}
'
import requests

url = "https://api.dualentry.com/public/v2/invoices/{record_number}/"

payload = {
"custom_fields": [{}],
"memo": "<string>",
"due_date": "2023-12-25",
"company_id": 123,
"customer_id": 123,
"exchange_rate": 123,
"items": [
{
"item_id": 123,
"quantity": 123,
"rate": 123,
"position": 123,
"memo": "<string>",
"discount_value": 123,
"discount_account_id": 123,
"record_level_discount_amount": 123,
"tax": {
"code": "<string>",
"rate": 123,
"amount": 123,
"is_taxable": True,
"tax_exempt_amount": 123,
"vat_rate_id": 123,
"gst_tax_rate_id": 123
},
"id": 123,
"classifications": [],
"company_id": 123
}
],
"bill_to_address": "<string>",
"billing_address": {
"street": "<string>",
"city": "<string>",
"postal_code": "<string>",
"state": "",
"country": "",
"second_line": "",
"name": "<string>"
},
"ship_to_address": "<string>",
"shipping_address": {
"street": "<string>",
"city": "<string>",
"postal_code": "<string>",
"state": "",
"country": "",
"second_line": "",
"name": "<string>"
},
"sales_order_id": 123,
"attachments": [
{
"id": 123,
"file_name": "<string>",
"file_size": 123,
"download_url": "<string>",
"upload_url": "<string>",
"category": "default"
}
],
"contracted": False,
"contract_id": 123,
"term_id": 123,
"reference_number": "",
"ar_account_id": 123,
"payment": {
"type": "<string>",
"id": 123,
"body": "<string>",
"link": "<string>"
},
"date": "2023-12-25",
"transaction_date": "2023-12-25",
"discount_value": 123
}
headers = {
"X-API-KEY": "<api-key>",
"Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PATCH',
headers: {'X-API-KEY': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
custom_fields: [{}],
memo: '<string>',
due_date: '2023-12-25',
company_id: 123,
customer_id: 123,
exchange_rate: 123,
items: [
{
item_id: 123,
quantity: 123,
rate: 123,
position: 123,
memo: '<string>',
discount_value: 123,
discount_account_id: 123,
record_level_discount_amount: 123,
tax: {
code: '<string>',
rate: 123,
amount: 123,
is_taxable: true,
tax_exempt_amount: 123,
vat_rate_id: 123,
gst_tax_rate_id: 123
},
id: 123,
classifications: [],
company_id: 123
}
],
bill_to_address: '<string>',
billing_address: {
street: '<string>',
city: '<string>',
postal_code: '<string>',
state: '',
country: '',
second_line: '',
name: '<string>'
},
ship_to_address: '<string>',
shipping_address: {
street: '<string>',
city: '<string>',
postal_code: '<string>',
state: '',
country: '',
second_line: '',
name: '<string>'
},
sales_order_id: 123,
attachments: [
{
id: 123,
file_name: '<string>',
file_size: 123,
download_url: '<string>',
upload_url: '<string>',
category: 'default'
}
],
contracted: false,
contract_id: 123,
term_id: 123,
reference_number: '',
ar_account_id: 123,
payment: {type: '<string>', id: 123, body: JSON.stringify('<string>'), link: '<string>'},
date: '2023-12-25',
transaction_date: '2023-12-25',
discount_value: 123
})
};

fetch('https://api.dualentry.com/public/v2/invoices/{record_number}/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "bill_to_address": "<string>",
  "ship_to_address": "<string>",
  "term_id": 123,
  "term_name": "<string>",
  "transaction_ids": [
    123
  ],
  "internal_id": 123,
  "number": 123,
  "company_id": 123,
  "company_name": "<string>",
  "company_currency": "<string>",
  "customer_id": 123,
  "exchange_rate": "<string>",
  "amount": "<string>",
  "amount_due": "<string>",
  "paid_total": "<string>",
  "amount_due_updated_at": "2023-11-07T05:31:56Z",
  "memo": "<string>",
  "date": "2023-12-25",
  "transaction_date": "2023-12-25",
  "due_date": "2023-12-25",
  "recurring_record_number": 123,
  "reference_number": "<string>",
  "created_at": "2023-11-07T05:31:56Z",
  "updated_at": "2023-11-07T05:31:56Z",
  "billing_address": {
    "street": "<string>",
    "second_line": "<string>",
    "city": "<string>",
    "state": "<string>",
    "postal_code": "<string>",
    "country": "<string>",
    "name": "<string>"
  },
  "shipping_address": {
    "street": "<string>",
    "second_line": "<string>",
    "city": "<string>",
    "state": "<string>",
    "postal_code": "<string>",
    "country": "<string>",
    "name": "<string>"
  },
  "custom_fields": [],
  "customer_name": "<string>",
  "attachments": [],
  "payment": {
    "type": "<string>",
    "id": 123,
    "body": "<string>",
    "link": "<string>"
  },
  "bank_match_status": "<string>",
  "reconciliation_status": "<string>",
  "created_by": {
    "actor_type": "<string>",
    "email": "<string>",
    "first_name": "<string>",
    "last_name": "<string>",
    "timestamp": "2023-11-07T05:31:56Z"
  },
  "updated_by": {
    "actor_type": "<string>",
    "email": "<string>",
    "first_name": "<string>",
    "last_name": "<string>",
    "timestamp": "2023-11-07T05:31:56Z"
  },
  "approval_status": "<string>",
  "next_approvers": [
    {
      "id": 123,
      "first_name": "<string>",
      "last_name": "<string>",
      "email": "<string>",
      "full_name": "<string>",
      "avatar_url": "<string>"
    }
  ],
  "rejected_by": {
    "id": 123,
    "first_name": "<string>",
    "last_name": "<string>",
    "email": "<string>",
    "full_name": "<string>",
    "rejection_reason": "<string>"
  },
  "items": [],
  "has_more_lines": false,
  "lines_count": 0
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}
{
"errors": {},
"success": false
}

Authorizations

X-API-KEY
string
header
required

Path Parameters

record_number
integer
required

The number attribute of the record.

Body

application/json

Partial update payload for PATCH /public/invoices/{number}/.

Every field is optional: send only the fields you want to change. Unset fields are left untouched on the existing record.

Updates allowed under the same constraints as PUT: period locks, payment-applied restrictions, and approval-workflow rules apply.

custom_fields
Custom Fields · object[] | null
memo
string | null
due_date
string<date> | null
company_id
integer | null
customer_id
integer | null
currency_iso_4217_code
enum<string> | null
Available options:
AED,
AFN,
ALL,
AMD,
ANG,
AOA,
ARS,
AUD,
AWG,
AZN,
BAM,
BBD,
BDT,
BGN,
BHD,
BIF,
BMD,
BND,
BOB,
BRL,
BSD,
BTN,
BWP,
BYN,
BZD,
CAD,
CDF,
CHF,
CLF,
CLP,
CNY,
COP,
CRC,
CUP,
CVE,
CZK,
DJF,
DKK,
DOP,
DZD,
EGP,
ERN,
ETB,
EUR,
FJD,
FKP,
GBP,
GEL,
GHS,
GIP,
GMD,
GNF,
GTQ,
GYD,
HKD,
HNL,
HTG,
HUF,
IDR,
ILS,
INR,
IQD,
IRR,
ISK,
JMD,
JOD,
JPY,
KES,
KGS,
KHR,
KMF,
KPW,
KRW,
KWD,
KYD,
KZT,
LAK,
LBP,
LKR,
LRD,
LSL,
LYD,
MAD,
MDL,
MGA,
MKD,
MMK,
MNT,
MOP,
MRU,
MUR,
MVR,
MWK,
MXN,
MYR,
MZN,
NAD,
NGN,
NIO,
NOK,
NPR,
NZD,
OMR,
PAB,
PEN,
PGK,
PHP,
PKR,
PLN,
PYG,
QAR,
RON,
RSD,
RUB,
RWF,
SAR,
SBD,
SCR,
SDG,
SEK,
SGD,
SHP,
SLL,
SOS,
SRD,
STN,
SVC,
SYP,
SZL,
THB,
TJS,
TMT,
TND,
TOP,
TRY,
TTD,
TWD,
TZS,
UAH,
UGX,
USD,
UYU,
UZS,
VES,
VND,
VUV,
WST,
XAF,
XAG,
XAU,
XCD,
XDR,
XOF,
XPD,
XPF,
XPT,
YER,
ZAR,
ZMW,
ZWL
exchange_rate
items
PublicInvoiceItemIn · object[] | null
bill_to_address
string | null
deprecated

Deprecated: send the structured billing_address / shipping_address instead.

billing_address
AddressSchemaIn · object | null
ship_to_address
string | null
deprecated

Deprecated: send the structured billing_address / shipping_address instead.

shipping_address
AddressSchemaIn · object | null
sales_order_id
integer | null
record_status
enum<string> | null
Available options:
draft,
posted,
archived
attachments
AttachmentSchemaOut · object[] | null
contracted
boolean
default:false
contract_id
integer | null
term_id
integer | null
reference_number
string
default:""
ar_account_id
integer | null
payment
PaymentSchemaIn · object | null

Schema for payment collection configuration input (matches frontend structure).

date
string<date> | null
transaction_date
string<date> | null
discount_type
enum<string> | null
Available options:
PERCENTAGE,
FIXED
discount_value

Response

OK

bill_to_address
string
required
deprecated

Deprecated: send the structured billing_address / shipping_address instead.

ship_to_address
string
required
deprecated

Deprecated: send the structured billing_address / shipping_address instead.

term_id
integer | null
required
term_name
string
required
transaction_ids
integer[]
required
internal_id
integer
required
number
integer
required
company_id
integer
required
company_name
string
required
company_currency
string
required
customer_id
integer | null
required
currency_iso_4217_code
enum<string>
required
Available options:
AED,
AFN,
ALL,
AMD,
ANG,
AOA,
ARS,
AUD,
AWG,
AZN,
BAM,
BBD,
BDT,
BGN,
BHD,
BIF,
BMD,
BND,
BOB,
BRL,
BSD,
BTN,
BWP,
BYN,
BZD,
CAD,
CDF,
CHF,
CLF,
CLP,
CNY,
COP,
CRC,
CUP,
CVE,
CZK,
DJF,
DKK,
DOP,
DZD,
EGP,
ERN,
ETB,
EUR,
FJD,
FKP,
GBP,
GEL,
GHS,
GIP,
GMD,
GNF,
GTQ,
GYD,
HKD,
HNL,
HTG,
HUF,
IDR,
ILS,
INR,
IQD,
IRR,
ISK,
JMD,
JOD,
JPY,
KES,
KGS,
KHR,
KMF,
KPW,
KRW,
KWD,
KYD,
KZT,
LAK,
LBP,
LKR,
LRD,
LSL,
LYD,
MAD,
MDL,
MGA,
MKD,
MMK,
MNT,
MOP,
MRU,
MUR,
MVR,
MWK,
MXN,
MYR,
MZN,
NAD,
NGN,
NIO,
NOK,
NPR,
NZD,
OMR,
PAB,
PEN,
PGK,
PHP,
PKR,
PLN,
PYG,
QAR,
RON,
RSD,
RUB,
RWF,
SAR,
SBD,
SCR,
SDG,
SEK,
SGD,
SHP,
SLL,
SOS,
SRD,
STN,
SVC,
SYP,
SZL,
THB,
TJS,
TMT,
TND,
TOP,
TRY,
TTD,
TWD,
TZS,
UAH,
UGX,
USD,
UYU,
UZS,
VES,
VND,
VUV,
WST,
XAF,
XAG,
XAU,
XCD,
XDR,
XOF,
XPD,
XPF,
XPT,
YER,
ZAR,
ZMW,
ZWL
exchange_rate
string
required
Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,16}0*$
amount
string
required

Total amount of transaction

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
amount_due
string
required

Amount to be paid

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
paid_total
string
required

Amount that was already paid by Customer Repayment Applications or Customer Payments

Pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d{0,2}0*$
amount_due_updated_at
string<date-time>
required

Timestamp of the most recent change that could have affected amount_due. Moves whenever the invoice itself is edited, or whenever a posted Customer Payment or Customer Prepayment Application referencing this invoice is written.

memo
string
required
date
string<date>
required

Posting date (GL date) - the date when the transaction is recorded in the general ledger

transaction_date
string<date>
required

Transaction date (inception date) - the date when the transaction actually occurred

due_date
string<date> | null
required
record_status
enum<string>
required
Available options:
draft,
posted,
archived
recurring_record_number
integer | null
required
reference_number
string
required
created_at
string<date-time>
required

Date and time the record was created

updated_at
string<date-time>
required

Date and time the record was last updated

billing_address
AddressSchemaOut · object | null
shipping_address
AddressSchemaOut · object | null
custom_fields
CustomFieldValuePairOutputSchema · object[]
customer_name
string | null
attachments
PublicAttachmentSchemaOut · object[]
payment
PaymentSchemaOut · object | null

Schema for payment collection configuration output.

bank_match_status
string | null
reconciliation_status
string | null
created_by
AuditActorSchemaOut · object | null

Schema for audit actor information.

updated_by
AuditActorSchemaOut · object | null

Schema for audit actor information.

approval_status
string | null
next_approvers
ApproverDictSchema · object[] | null
rejected_by
RejectedBySchema · object | null

Schema for rejector information including rejection reason.

items
PublicInvoiceItemOut · object[]
has_more_lines
boolean
default:false
lines_count
integer
default:0
Last modified on July 13, 2026